Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90	(revision 9125)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90	(revision 9169)
@@ -4,10 +4,10 @@
    !! TOP :   PISCES CALCULATES GAS EXCHANGE AND CHEMISTRY AT SEA SURFACE
    !!======================================================================
-   !! History :    -   !  1988-07  (E. MAIER-REIMER) Original code
-   !!              -   !  1998     (O. Aumont) additions
-   !!              -   !  1999     (C. Le Quere) modifications
-   !!             1.0  !  2004     (O. Aumont) modifications
-   !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
-   !!                  !  2011-02  (J. Simeon, J. Orr) Include total atm P correction 
+   !! History :   -   !  1988-07  (E. MAIER-REIMER) Original code
+   !!             -   !  1998     (O. Aumont) additions
+   !!             -   !  1999     (C. Le Quere) modifications
+   !!            1.0  !  2004     (O. Aumont) modifications
+   !!            2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!                 !  2011-02  (J. Simeon, J. Orr) Include total atm P correction 
    !!----------------------------------------------------------------------
    !!   p4z_flx       :   CALCULATES GAS EXCHANGE AND CHEMISTRY AT SEA SURFACE
@@ -15,11 +15,11 @@
    !!   p4z_patm      :   Read sfc atm pressure [atm] for each grid cell
    !!----------------------------------------------------------------------
-   USE oce_trc                      !  shared variables between ocean and passive tracers 
-   USE trc                          !  passive tracers common variables
-   USE sms_pisces                   !  PISCES Source Minus Sink variables
-   USE p4zche                       !  Chemical model
-   USE prtctl_trc                   !  print control for debugging
-   USE iom                          !  I/O manager
-   USE fldread                      !  read input fields
+   USE oce_trc        !  shared variables between ocean and passive tracers 
+   USE trc            !  passive tracers common variables
+   USE sms_pisces     !  PISCES Source Minus Sink variables
+   USE p4zche         !  Chemical model
+   USE prtctl_trc     !  print control for debugging
+   USE iom            !  I/O manager
+   USE fldread        !  read input fields
 
    IMPLICIT NONE
@@ -30,25 +30,25 @@
    PUBLIC   p4z_flx_alloc  
 
-   !                               !!** Namelist  nampisext  **
-   REAL(wp)          ::  atcco2     !: pre-industrial atmospheric [co2] (ppm) 	
-   LOGICAL           ::  ln_co2int  !: flag to read in a file and interpolate atmospheric pco2 or not
-   CHARACTER(len=34) ::  clname     !: filename of pco2 values
-   INTEGER           ::  nn_offset  !: Offset model-data start year (default = 0) 
+   !                                 !!** Namelist  nampisext  **
+   REAL(wp)          ::   atcco2      !: pre-industrial atmospheric [co2] (ppm) 	
+   LOGICAL           ::   ln_co2int   !: flag to read in a file and interpolate atmospheric pco2 or not
+   CHARACTER(len=34) ::   clname      !: filename of pco2 values
+   INTEGER           ::   nn_offset   !: Offset model-data start year (default = 0) 
 
    !!  Variables related to reading atmospheric CO2 time history    
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) :: atcco2h, years
-   INTEGER  :: nmaxrec, numco2
-
-   !                               !!* nampisatm namelist (Atmospheric PRessure) *
+   INTEGER                                   ::   nmaxrec, numco2   !
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::   atcco2h, years    !
+
+   !                                  !!* nampisatm namelist (Atmospheric PRessure) *
    LOGICAL, PUBLIC ::   ln_presatm     !: ref. pressure: global mean Patm (F) or a constant (F)
    LOGICAL, PUBLIC ::   ln_presatmco2  !: accounting for spatial atm CO2 in the compuation of carbon flux (T) or not (F)
 
-   REAL(wp) , ALLOCATABLE, SAVE, DIMENSION(:,:) ::  patm      ! atmospheric pressure at kt                 [N/m2]
-   TYPE(FLD), ALLOCATABLE,       DIMENSION(:)   ::  sf_patm   ! structure of input fields (file informations, fields read)
-   TYPE(FLD), ALLOCATABLE,       DIMENSION(:)   ::  sf_atmco2 ! structure of input fields (file informations, fields read)
-
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: satmco2   !: atmospheric pco2 
-
-   REAL(wp) ::  xconv  = 0.01_wp / 3600._wp !: coefficients for conversion 
+   REAL(wp) , ALLOCATABLE, SAVE, DIMENSION(:,:) ::   patm      ! atmospheric pressure at kt                 [N/m2]
+   TYPE(FLD), ALLOCATABLE,       DIMENSION(:)   ::   sf_patm   ! structure of input fields (file informations, fields read)
+   TYPE(FLD), ALLOCATABLE,       DIMENSION(:)   ::   sf_atmco2 ! structure of input fields (file informations, fields read)
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::  satmco2   !: atmospheric pco2 
+
+   REAL(wp) ::   xconv  = 0.01_wp / 3600._wp   !: coefficients for conversion 
 
    !!----------------------------------------------------------------------
@@ -70,5 +70,4 @@
       !!              - Add option for time-interpolation of atcco2.txt  
       !!---------------------------------------------------------------------
-      !
       INTEGER, INTENT(in) ::   kt, knt   !
       !
@@ -79,17 +78,16 @@
       REAL(wp) ::   zph, zdic, zsch_o2, zsch_co2
       REAL(wp) ::   zyr_dec, zdco2dt
-      CHARACTER (len=25) :: charout
-      REAL(wp), DIMENSION(jpi,jpj) :: zkgco2, zkgo2, zh2co3, zoflx,  zpco2atm  
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: zw2d
+      CHARACTER (len=25) ::   charout
+      REAL(wp), DIMENSION(jpi,jpj) ::   zkgco2, zkgo2, zh2co3, zoflx,  zpco2atm  
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   zw2d
       !!---------------------------------------------------------------------
       !
       IF( ln_timing )   CALL timing_start('p4z_flx')
       !
-
       ! SURFACE CHEMISTRY (PCO2 AND [H+] IN
       !     SURFACE LAYER); THE RESULT OF THIS CALCULATION
       !     IS USED TO COMPUTE AIR-SEA FLUX OF CO2
 
-      IF( kt /= nit000 .AND. .NOT.l_co2cpl .AND. knt == 1 ) CALL p4z_patm( kt )    ! Get sea-level pressure (E&K [1981] climatology) for use in flux calcs
+      IF( kt /= nit000 .AND. .NOT.l_co2cpl .AND. knt == 1 )   CALL p4z_patm( kt )   ! Get sea-level pressure (E&K [1981] climatology) for use in flux calcs
 
       IF( ln_co2int .AND. .NOT.ln_presatmco2 .AND. .NOT.l_co2cpl ) THEN 
@@ -226,40 +224,43 @@
       !! ** Method  :   Read the nampisext namelist and check the parameters
       !!      called at the first timestep (nittrc000)
+      !!
       !! ** input   :   Namelist nampisext
       !!----------------------------------------------------------------------
-      INTEGER ::   jm
-      INTEGER ::   ios   ! Local integer 
-      !
+      INTEGER ::   jm, ios   ! Local integer 
+      !!
       NAMELIST/nampisext/ln_co2int, atcco2, clname, nn_offset
       !!----------------------------------------------------------------------
-      !
-
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' p4z_flx_init : atmospheric conditions for air-sea flux calculation'
+         WRITE(numout,*) ' ~~~~~~~~~~~~'
+      ENDIF
+      !
       REWIND( numnatp_ref )              ! Namelist nampisext in reference namelist : Pisces atm. conditions
       READ  ( numnatp_ref, nampisext, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisext in reference namelist', lwp )
-
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'nampisext in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist nampisext in configuration namelist : Pisces atm. conditions
       READ  ( numnatp_cfg, nampisext, IOSTAT = ios, ERR = 902 )
-902   IF( ios >  0 ) CALL ctl_nam ( ios , 'nampisext in configuration namelist', lwp )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'nampisext in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, nampisext )
       !
       IF(lwp) THEN                         ! control print
-         WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist parameters for air-sea exchange, nampisext'
-         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '    Choice for reading in the atm pCO2 file or constant value, ln_co2int =', ln_co2int
-         WRITE(numout,*) ' '
-      ENDIF
+         WRITE(numout,*) '   Namelist : nampisext --- parameters for air-sea exchange'
+         WRITE(numout,*) '      reading in the atm pCO2 file or constant value   ln_co2int =', ln_co2int
+      ENDIF
+
+!!gm  BUG !!!   ===>>>  ln_presatm and ln_presatmco2 are used below, but read in namelist 
+!!gm                    at the end of the routine via a CALL to CALL p4z_patm( nit000 )
+
      IF( .NOT.ln_co2int .AND. .NOT.ln_presatmco2 ) THEN
          IF(lwp) THEN                         ! control print
-            WRITE(numout,*) '    Constant Atmospheric pCO2 value  atcco2    =', atcco2
-            WRITE(numout,*) ' '
+            WRITE(numout,*) '         Constant Atmospheric pCO2 value               atcco2    =', atcco2
          ENDIF
          satmco2(:,:)  = atcco2      ! Initialisation of atmospheric pco2
       ELSEIF( ln_co2int .AND. .NOT.ln_presatmco2 ) THEN
          IF(lwp)  THEN
-            WRITE(numout,*) '    Atmospheric pCO2 value  from file clname      =', TRIM( clname )
-            WRITE(numout,*) '    Offset model-data start year      nn_offset   =', nn_offset
-            WRITE(numout,*) ' '
+            WRITE(numout,*) '         Constant Atmospheric pCO2 value               atcco2    =', atcco2
+            WRITE(numout,*) '         Atmospheric pCO2 value  from file             clname    =', TRIM( clname )
+            WRITE(numout,*) '         Offset model-data start year                  nn_offset =', nn_offset
          ENDIF
          CALL ctl_opn( numco2, TRIM( clname) , 'OLD', 'FORMATTED', 'SEQUENTIAL', -1 , numout, lwp )
@@ -270,7 +271,7 @@
          END DO
  100     nmaxrec = jm - 1 
-         ALLOCATE( years  (nmaxrec) )     ;      years  (:) = 0._wp
-         ALLOCATE( atcco2h(nmaxrec) )     ;      atcco2h(:) = 0._wp
-
+         ALLOCATE( years  (nmaxrec) )   ;   years  (:) = 0._wp
+         ALLOCATE( atcco2h(nmaxrec) )   ;   atcco2h(:) = 0._wp
+         !
          REWIND(numco2)
          DO jm = 1, nmaxrec          ! get  xCO2 data
@@ -282,10 +283,8 @@
          IF(lwp)  THEN
             WRITE(numout,*) '    Spatialized Atmospheric pCO2 from an external file'
-            WRITE(numout,*) ' '
          ENDIF
       ELSE
          IF(lwp)  THEN
             WRITE(numout,*) '    Spatialized Atmospheric pCO2 from an external file'
-            WRITE(numout,*) ' '
          ENDIF
       ENDIF
@@ -304,38 +303,39 @@
       !!                  ***  ROUTINE p4z_atm  ***
       !!
-      !! ** Purpose :   Read and interpolate the external atmospheric sea-levl pressure
+      !! ** Purpose :   Read and interpolate the external atmospheric sea-level pressure
       !! ** Method  :   Read the files and interpolate the appropriate variables
       !!
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in  ) ::   kt   ! ocean time step
-      !
-      INTEGER            ::  ierr
-      INTEGER            ::  ios      ! Local integer output status for namelist read
-      CHARACTER(len=100) ::  cn_dir   ! Root directory for location of ssr files
-      TYPE(FLD_N)        ::  sn_patm  ! informations about the fields to be read
-      TYPE(FLD_N)        ::  sn_atmco2 ! informations about the fields to be read
+      INTEGER, INTENT(in) ::   kt   ! ocean time step
+      !
+      INTEGER            ::   ierr, ios   ! Local integer
+      CHARACTER(len=100) ::   cn_dir      ! Root directory for location of ssr files
+      TYPE(FLD_N)        ::   sn_patm     ! informations about the fields to be read
+      TYPE(FLD_N)        ::   sn_atmco2   ! informations about the fields to be read
       !!
       NAMELIST/nampisatm/ ln_presatm, ln_presatmco2, sn_patm, sn_atmco2, cn_dir
       !!----------------------------------------------------------------------
-
-      !                                         ! ----------------------- !
-      IF( kt == nit000 ) THEN                   ! First call kt=nittrc000 !
-
+      !
+      IF( kt == nit000 ) THEN    !==  First call kt=nittrc000  ==!
+         !
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) ' p4z_patm : sea-level atmospheric pressure'
+            WRITE(numout,*) ' ~~~~~~~~'
+         ENDIF
+         !
          REWIND( numnatp_ref )              ! Namelist nampisatm in reference namelist : Pisces atm. sea level pressure file
          READ  ( numnatp_ref, nampisatm, IOSTAT = ios, ERR = 901)
 901      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisatm in reference namelist', lwp )
-
          REWIND( numnatp_cfg )              ! Namelist nampisatm in configuration namelist : Pisces atm. sea level pressure file 
          READ  ( numnatp_cfg, nampisatm, IOSTAT = ios, ERR = 902 )
-902      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisatm in configuration namelist', lwp )
+902      IF( ios >  0 )   CALL ctl_nam ( ios , 'nampisatm in configuration namelist', lwp )
          IF(lwm) WRITE ( numonp, nampisatm )
          !
          !
          IF(lwp) THEN                                 !* control print
-            WRITE(numout,*)
-            WRITE(numout,*) '   Namelist nampisatm : Atmospheric Pressure as external forcing'
-            WRITE(numout,*) '      constant atmopsheric pressure (F) or from a file (T)  ln_presatm = ', ln_presatm
-            WRITE(numout,*) '      spatial atmopsheric CO2 for flux calcs  ln_presatmco2 = ', ln_presatmco2
-            WRITE(numout,*)
+            WRITE(numout,*) '   Namelist : nampisatm --- Atmospheric Pressure as external forcing'
+            WRITE(numout,*) '      constant atmopsheric pressure (F) or from a file (T)  ln_presatm    = ', ln_presatm
+            WRITE(numout,*) '      spatial atmopsheric CO2 for flux calcs                ln_presatmco2 = ', ln_presatmco2
          ENDIF
          !
@@ -358,5 +358,5 @@
          ENDIF
          !
-         IF( .NOT.ln_presatm )   patm(:,:) = 1.e0    ! Initialize patm if no reading from a file
+         IF( .NOT.ln_presatm )   patm(:,:) = 1._wp    ! Initialize patm if no reading from a file
          !
       ENDIF
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zligand.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zligand.F90	(revision 9125)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zligand.F90	(revision 9169)
@@ -6,11 +6,11 @@
    !! History :   3.6  !  2016-03  (O. Aumont, A. Tagliabue) Quota model and reorganization
    !!----------------------------------------------------------------------
-   !!   p4z_ligand       :  Compute remineralization/dissolution of organic ligands
-   !!   p4z_ligand_init  :  Initialisation of parameters for remineralisation
+   !!   p4z_ligand     :  Compute remineralization/dissolution of organic ligands
+   !!   p4z_ligand_init:  Initialisation of parameters for remineralisation
    !!----------------------------------------------------------------------
-   USE oce_trc         !  shared variables between ocean and passive tracers
-   USE trc             !  passive tracers common variables 
-   USE sms_pisces      !  PISCES Source Minus Sink variables
-   USE prtctl_trc      !  print control for debugging
+   USE oce_trc         ! shared variables between ocean and passive tracers
+   USE trc             ! passive tracers common variables 
+   USE sms_pisces      ! PISCES Source Minus Sink variables
+   USE prtctl_trc      ! print control for debugging
 
    IMPLICIT NONE
@@ -20,5 +20,4 @@
    PUBLIC   p4z_ligand_init    ! called in trcsms_pisces.F90
 
-   !! * Shared module variables
    REAL(wp), PUBLIC ::  rlgw     !: lifetime (years) of weak ligands
    REAL(wp), PUBLIC ::  rlgs     !: lifetime (years) of strong ligands
@@ -39,23 +38,21 @@
       !!
       !! ** Purpose :   Compute remineralization/scavenging of organic ligands
-      !!
-      !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      !
       INTEGER, INTENT(in) ::   kt, knt ! ocean time step
       !
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zlgwp, zlgwpr, zlgwr, zlablgw, zrfepa, zfepr
-      CHARACTER (len=25) :: charout
+      CHARACTER (len=25) ::   charout
       !!---------------------------------------------------------------------
       !
       IF( ln_timing )   CALL timing_start('p4z_ligand')
       !
-      ! ------------------------------------------------------------------
-      ! Remineralization of iron ligands
-      ! ------------------------------------------------------------------
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
+               !
+               ! ------------------------------------------------------------------
+               ! Remineralization of iron ligands
+               ! ------------------------------------------------------------------
                ! production from remineralisation of organic matter
                zlgwp  = orem(ji,jj,jk) * rlig
@@ -68,14 +65,8 @@
                zlgwpr = prlgw * xstep * etot(ji,jj,jk) * trb(ji,jj,jk,jplgw) * (1. - fr_i(ji,jj))
                tra(ji,jj,jk,jplgw) = tra(ji,jj,jk,jplgw) + zlgwp - zlgwr - zlgwpr
-            END DO
-         END DO
-      END DO
-
-      ! ----------------------------------------------------------
-      ! Dissolution of nanoparticle Fe
-      ! ----------------------------------------------------------
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
+               !
+               ! ----------------------------------------------------------
+               ! Dissolution of nanoparticle Fe
+               ! ----------------------------------------------------------
                ! dissolution rate is maximal in the presence of light and 
                ! lower in the aphotici zone
@@ -86,13 +77,14 @@
                tra(ji,jj,jk,jpfep) = tra(ji,jj,jk,jpfep) - zfepr
                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zfepr
+               !
             END DO
          END DO
       END DO
-
+      !
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('ligand1')")
          CALL prt_ctl_trc_info(charout)
          CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-       ENDIF
+      ENDIF
       !
       IF( ln_timing )   CALL timing_stop('p4z_ligand')
@@ -108,8 +100,6 @@
       !!
       !! ** Method  :   Read the nampislig namelist and check the parameters
-      !!      called at the first timestep
       !!
       !! ** input   :   Namelist nampislig
-      !!
       !!----------------------------------------------------------------------
       INTEGER ::   ios   ! Local integer 
@@ -117,23 +107,25 @@
       NAMELIST/nampislig/ rlgw, prlgw, rlgs, rfep, rlig
       !!----------------------------------------------------------------------
-
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'p4z_ligand_init : remineralization/scavenging of organic ligands'
+         WRITE(numout,*) '~~~~~~~~~~~~~~~'
+      ENDIF
       REWIND( numnatp_ref )              ! Namelist nampislig in reference namelist : Pisces remineralization
       READ  ( numnatp_ref, nampislig, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampislig in reference namelist', lwp )
-
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'nampislig in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist nampislig in configuration namelist : Pisces remineralization
       READ  ( numnatp_cfg, nampislig, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampislig in configuration namelist', lwp )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'nampislig in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, nampislig )
-
+      !
       IF(lwp) THEN                         ! control print
-         WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist parameters for ligands, nampislig'
-         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '    Dissolution rate of FeP                        rfep =', rfep
-         WRITE(numout,*) '    Lifetime (years) of weak ligands               rlgw =', rlgw
-         WRITE(numout,*) '    Remin ligand production per unit C             rlig =', rlig
-         WRITE(numout,*) '    Photolysis of weak ligand                     prlgw =', prlgw
-         WRITE(numout,*) '    Lifetime (years) of strong ligands             rlgs =', rlgs
+         WRITE(numout,*) '   Namelist : nampislig'
+         WRITE(numout,*) '      Dissolution rate of FeP                      rfep  =', rfep
+         WRITE(numout,*) '      Lifetime (years) of weak ligands             rlgw  =', rlgw
+         WRITE(numout,*) '      Remin ligand production per unit C           rlig  =', rlig
+         WRITE(numout,*) '      Photolysis of weak ligand                    prlgw =', prlgw
+         WRITE(numout,*) '      Lifetime (years) of strong ligands           rlgs  =', rlgs
       ENDIF
       !
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90	(revision 9125)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90	(revision 9169)
@@ -215,9 +215,9 @@
       !
       IF( lk_iomput .AND. knt == nrdttrc ) THEN        ! save output diagnostics
-        IF( iom_use( "xfracal" ) ) CALL iom_put( "xfracal", xfracal(:,:,:) * tmask(:,:,:) )  ! euphotic layer deptht
-        IF( iom_use( "LNnut"   ) ) CALL iom_put( "LNnut"  , xlimphy(:,:,:) * tmask(:,:,:) )  ! Nutrient limitation term
-        IF( iom_use( "LDnut"   ) ) CALL iom_put( "LDnut"  , xlimdia(:,:,:) * tmask(:,:,:) )  ! Nutrient limitation term
-        IF( iom_use( "LNFe"    ) ) CALL iom_put( "LNFe"   , xlimnfe(:,:,:) * tmask(:,:,:) )  ! Iron limitation term
-        IF( iom_use( "LDFe"    ) ) CALL iom_put( "LDFe"   , xlimdfe(:,:,:) * tmask(:,:,:) )  ! Iron limitation term
+        IF( iom_use( "xfracal" ) )   CALL iom_put( "xfracal", xfracal(:,:,:) * tmask(:,:,:) )  ! euphotic layer deptht
+        IF( iom_use( "LNnut"   ) )   CALL iom_put( "LNnut"  , xlimphy(:,:,:) * tmask(:,:,:) )  ! Nutrient limitation term
+        IF( iom_use( "LDnut"   ) )   CALL iom_put( "LDnut"  , xlimdia(:,:,:) * tmask(:,:,:) )  ! Nutrient limitation term
+        IF( iom_use( "LNFe"    ) )   CALL iom_put( "LNFe"   , xlimnfe(:,:,:) * tmask(:,:,:) )  ! Iron limitation term
+        IF( iom_use( "LDFe"    ) )   CALL iom_put( "LDFe"   , xlimdfe(:,:,:) * tmask(:,:,:) )  ! Iron limitation term
       ENDIF
       !
@@ -246,37 +246,40 @@
       !!----------------------------------------------------------------------
       !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'p4z_lim_init : initialization of nutrient limitations'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+      !
       REWIND( numnatp_ref )              ! Namelist nampislim in reference namelist : Pisces nutrient limitation parameters
       READ  ( numnatp_ref, namp4zlim, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namp4zlim in reference namelist', lwp )
-      !
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namp4zlim in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist nampislim in configuration namelist : Pisces nutrient limitation parameters 
       READ  ( numnatp_cfg, namp4zlim, IOSTAT = ios, ERR = 902 )
-902   IF( ios >  0 ) CALL ctl_nam ( ios , 'namp4zlim in configuration namelist', lwp )
-      IF(lwm) WRITE ( numonp, namp4zlim )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namp4zlim in configuration namelist', lwp )
+      IF(lwm) WRITE( numonp, namp4zlim )
       !
       IF(lwp) THEN                         ! control print
-         WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist parameters for nutrient limitations, namp4zlim'
-         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '    mean rainratio                           caco3r    = ', caco3r
-         WRITE(numout,*) '    NO3 half saturation of nanophyto         concnno3  = ', concnno3
-         WRITE(numout,*) '    NO3 half saturation of diatoms           concdno3  = ', concdno3
-         WRITE(numout,*) '    NH4 half saturation for phyto            concnnh4  = ', concnnh4
-         WRITE(numout,*) '    NH4 half saturation for diatoms          concdnh4  = ', concdnh4
-         WRITE(numout,*) '    half saturation constant for Si uptake   xksi1     = ', xksi1
-         WRITE(numout,*) '    half saturation constant for Si/C        xksi2     = ', xksi2
-         WRITE(numout,*) '    half-sat. of DOC remineralization        xkdoc     = ', xkdoc
-         WRITE(numout,*) '    Iron half saturation for nanophyto       concnfer  = ', concnfer
-         WRITE(numout,*) '    Iron half saturation for diatoms         concdfer  = ', concdfer
-         WRITE(numout,*) '    size ratio for nanophytoplankton         xsizern   = ', xsizern
-         WRITE(numout,*) '    size ratio for diatoms                   xsizerd   = ', xsizerd
-         WRITE(numout,*) '    NO3 half saturation of bacteria          concbno3  = ', concbno3
-         WRITE(numout,*) '    NH4 half saturation for bacteria         concbnh4  = ', concbnh4
-         WRITE(numout,*) '    Minimum size criteria for diatoms        xsizedia  = ', xsizedia
-         WRITE(numout,*) '    Minimum size criteria for nanophyto      xsizephy  = ', xsizephy
-         WRITE(numout,*) '    Fe half saturation for bacteria          concbfe   = ', concbfe
-         WRITE(numout,*) '    halk saturation constant for anoxia       oxymin   =' , oxymin
-         WRITE(numout,*) '    optimal Fe quota for nano.               qnfelim   = ', qnfelim
-         WRITE(numout,*) '    Optimal Fe quota for diatoms             qdfelim   = ', qdfelim
+         WRITE(numout,*) '   Namelist : namp4zlim'
+         WRITE(numout,*) '      mean rainratio                           caco3r    = ', caco3r
+         WRITE(numout,*) '      NO3 half saturation of nanophyto         concnno3  = ', concnno3
+         WRITE(numout,*) '      NO3 half saturation of diatoms           concdno3  = ', concdno3
+         WRITE(numout,*) '      NH4 half saturation for phyto            concnnh4  = ', concnnh4
+         WRITE(numout,*) '      NH4 half saturation for diatoms          concdnh4  = ', concdnh4
+         WRITE(numout,*) '      half saturation constant for Si uptake   xksi1     = ', xksi1
+         WRITE(numout,*) '      half saturation constant for Si/C        xksi2     = ', xksi2
+         WRITE(numout,*) '      half-sat. of DOC remineralization        xkdoc     = ', xkdoc
+         WRITE(numout,*) '      Iron half saturation for nanophyto       concnfer  = ', concnfer
+         WRITE(numout,*) '      Iron half saturation for diatoms         concdfer  = ', concdfer
+         WRITE(numout,*) '      size ratio for nanophytoplankton         xsizern   = ', xsizern
+         WRITE(numout,*) '      size ratio for diatoms                   xsizerd   = ', xsizerd
+         WRITE(numout,*) '      NO3 half saturation of bacteria          concbno3  = ', concbno3
+         WRITE(numout,*) '      NH4 half saturation for bacteria         concbnh4  = ', concbnh4
+         WRITE(numout,*) '      Minimum size criteria for diatoms        xsizedia  = ', xsizedia
+         WRITE(numout,*) '      Minimum size criteria for nanophyto      xsizephy  = ', xsizephy
+         WRITE(numout,*) '      Fe half saturation for bacteria          concbfe   = ', concbfe
+         WRITE(numout,*) '      halk saturation constant for anoxia       oxymin   =' , oxymin
+         WRITE(numout,*) '      optimal Fe quota for nano.               qnfelim   = ', qnfelim
+         WRITE(numout,*) '      Optimal Fe quota for diatoms             qdfelim   = ', qdfelim
       ENDIF
       !
